"use strict";var RichTextparser;global.define=function(a,b){RichTextparser=b({getGlobalSpace:function getGlobalSpace(){return global},removeHTMLTags:function removeHTMLTags(a){return"string"==typeof a?a.replaceAll(/<[^>]*>/g,""):a},decodeHtmlEntities:function decodeHtmlEntities(a){return a.replace(/&#(\d+);/g,function(a,b){return String.fromCharCode(b)}).replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&quot;/g,"\"").replace(/&apos;/g,"'").replace(/&nbsp;/g," ")}},function $(){return{text:function text(b){return b}}})},require("./Expression"),test("Test var define/assign",function(){var a=new RichTextparser;a.parse("[var a = 123; write(a)]");var b=a.evaluate({});expect(b).toBe("123")}),test("Test multi var define/assign no then",function(){var a=new RichTextparser;a.parse("[var a,b,c = 123; write(a + ',' + b + ',' + c)]");var b=a.evaluate({});expect(b).toBe("undefined,undefined,123")}),test("Test multi var define/assign then assign",function(){var a=new RichTextparser;a.parse("[var a,b,c = 123; b='aValue'; write(a + ',' + b + ',' + c)]");var b=a.evaluate({});expect(b).toBe("undefined,aValue,123")}),test("Test var assignment 1",function(){var a=new RichTextparser;a.parse("[var average = 4;var value,b,c=1;value = 1+1+1+1+1;write(value);]");var b=a.evaluate({});expect(b).toBe("5")}),test("Test var assignment 2",function(){var a=new RichTextparser;a.parse("[var value;value = 1+1+1+1+1;write(value);]");var b=a.evaluate({});expect(b).toBe("5")}),test("Test assign to a number",function(){var a=new RichTextparser;a.parse("[1 = 123;]");var b=a.evaluate({});expect(b).toContain("Invalid left-hand side in assignment")}),test("Test assign to a boolean",function(){var a=new RichTextparser;a.parse("[false = 123;]");var b=a.evaluate({});expect(b).toContain("Invalid left-hand side in assignment")}),test("Test assign to a function execution",function(){var a=new RichTextparser;a.parse("[date() = 123;]");var b=a.evaluate({});expect(b).toContain("Invalid left-hand side in assignment")}),test("Test append operation with a var",function(){var a=new RichTextparser;a.parse("[var a = 'value'; a+=2; write(a)]");var b=a.evaluate({});expect(b).toBe("value2")}),test("Test append operation with a number",function(){var a=new RichTextparser;a.parse("[var a += 1; write(a)]");var b=a.evaluate({});expect(b).toContain("Invalid left-hand side in append operation")}),test("Test append operation with a string",function(){var a=new RichTextparser;a.parse("[var a = 'value'; a+=2; write(a)]");var b=a.evaluate({});expect(b).toBe("value2")}),test("Test pre increment",function(){var a=new RichTextparser;a.parse("[var a = 1; write(a++); write(','); write(a);]");var b=a.evaluate({});expect(b).toBe("1,2")}),test("Test pre decrement",function(){var a=new RichTextparser;a.parse("[var a = 1; write(a--); write(','); write(a);]");var b=a.evaluate({});expect(b).toBe("1,0")}),test("Test post increment",function(){var a=new RichTextparser;a.parse("[var a = 1; write(++a); write(','); write(a);]");var b=a.evaluate({});expect(b).toBe("2,2")}),test("Test post decrement",function(){var a=new RichTextparser;a.parse("[var a = 1; write(--a); write(','); write(a);]");var b=a.evaluate({});expect(b).toBe("0,0")}),test("Test pre increment and addition",function(){var a=new RichTextparser;a.parse("[var a = 1; write(a++ + a);]");var b=a.evaluate({});expect(b).toBe("3")}),test("Test pre increment and addition",function(){var a=new RichTextparser;a.parse("[var a = 1; write(++a + a);]");var b=a.evaluate({});expect(b).toBe("4")}),test("Test math with multiple additions",function(){var a=new RichTextparser;a.parse("[write(1 + 2 + 3 + 4);]");var b=a.evaluate({});expect(b).toBe("10")}),test("Test math with multiple additions wtih multipliccation 1 ",function(){var a=new RichTextparser;a.parse("[write(3 * 2 + 5 + 5 + 2 * 4);]");var b=a.evaluate({});expect(b).toBe("24")}),test("Test math with multiple additions wtih multipliccation 2",function(){var a=new RichTextparser;a.parse("[write(3 * 2 + 5 * 5 + 2 * 4);]");var b=a.evaluate({});expect(b).toBe("39")}),test("Test math with multiple additions wtih multipliccation 3",function(){var a=new RichTextparser;a.parse("[write(5 + 2 / 2 * 4);]");var b=a.evaluate({});expect(b).toBe("9")}),test("Test math with multiple additions wtih multipliccation 4",function(){var a=new RichTextparser;a.parse("[write(3 * 2 + 5 * 5 + 2 / 2 * 4);]");var b=a.evaluate({});expect(b).toBe("35")}),test("Test math with multiple additions wtih multipliccation 5",function(){var a=new RichTextparser;a.parse("[write(3 * 2 + 5 * 5 + 2  * 4 / 4);]");var b=a.evaluate({});expect(b).toBe("33")}),test("Test math with brackets",function(){var a=new RichTextparser;a.parse("[write(3 * (2 + 5) + (5 + 2) * 4);]");var b=a.evaluate({});expect(b).toBe("49")}),test("Test function call on string",function(){var a=new RichTextparser;a.parse("[ var s = 'abc'; write(s.charAt(1)); ]");var b=a.evaluate({});expect(b).toBe("b")}),test("Test chained function call on string",function(){var a=new RichTextparser;a.parse("[ var s = 'abc'; write(s.charAt(1).toUpperCase()); ]");var b=a.evaluate({});expect(b).toBe("B")}),test("Test chained function call in a variable",function(){var a=new RichTextparser;a.parse("[ var s = 'abc'.charAt(1).toUpperCase(); write(s); ]");var b=a.evaluate({});expect(b).toBe("B")}),test("Test Array",function(){var a=new RichTextparser;a.parse("[ var a =[1,2,3,4]; write(a.join('|')); ]");var b=a.evaluate({});expect(b).toBe("1|2|3|4")}),test("Test 2d array",function(){var a=new RichTextparser;a.parse("[ var a =[['a','b'],['c','d'],['e','f']]; write(a[2].join('|')); ]");var b=a.evaluate({});expect(b).toBe("e|f")}),test("Test Math function",function(){var a=new RichTextparser;a.parse("[ write(Math.max(1,2,3)) ]");var b=a.evaluate({});expect(b).toBe("3")}),test("Test Math attribute",function(){var a=new RichTextparser;a.parse("[write(Math.PI)]");var b=a.evaluate({});expect(b).toBe("3.141592653589793")}),test("Test Date ",function(){var a=new RichTextparser;a.parse("[write(date('08/02/1978'))]");var b=a.evaluate({});expect(b).toBe("Wed Aug 02 1978 00:00:00 GMT-0400 (Eastern Daylight Time)")}),test("Test Date 2",function(){var a=new RichTextparser;a.parse("[write(date(1995, 11, 17))]");var b=a.evaluate({});expect(b).toBe("Sun Dec 17 1995 00:00:00 GMT-0500 (Eastern Standard Time)")}),test("Test Date 3",function(){var a=new RichTextparser;a.parse("[write(date(1995, 11, 17, 3, 24, 0))]");var b=a.evaluate({});expect(b).toBe("Sun Dec 17 1995 03:24:00 GMT-0500 (Eastern Standard Time)")}),test("Test Date parse",function(){var a=new RichTextparser;a.parse("[write(Date.parse('10/02/1978'))]");var b=a.evaluate({});expect(b).toBe("276148800000")}),test("Test Date split",function(){var a=new RichTextparser;a.parse("[write(date('08/02/1978').toISOString().split('T')[0])]");var b=a.evaluate({});expect(b).toBe("1978-08-02")}),test("Test if/then/else - then",function(){var a=new RichTextparser;a.parse("[var average = 2;var value = 1 + 1 + 1;if ( value > average ){  write('The value is above average');} else {  write('The value is below average');}]");var b=a.evaluate({});expect(b).toBe("The value is above average")}),test("Test if/then/else - else",function(){var a=new RichTextparser;a.parse("[var average = 4;var value = 5 - 2;if ( value > average ){  write('The value is above average');} else {  write('The value is below average' );}]");var b=a.evaluate({});expect(b).toBe("The value is below average")}),test("Test JSON 1",function(){var a=new RichTextparser;a.parse("[var json = {a:1,b:'123',c:Math.max(7,8,9)};write(stringify(json));]");var b=a.evaluate({});expect(b).toBe("{\"a\":1,\"b\":\"123\",\"c\":9}")}),test("Test JSON 2",function(){var a=new RichTextparser;a.parse("[var json = {a:1,b:'123',c:Math.max(7,8,9)+10};write(JSON.stringify(json));]");var b=a.evaluate({});expect(b).toBe("{\"a\":1,\"b\":\"123\",\"c\":19}")}),test("Test JSON 3",function(){var a=new RichTextparser;a.parse("[var json = {a:1,b:'123',c:Math.max(7,8,9)+10};write(json.c + 2);]");var b=a.evaluate({});expect(b).toBe("21")}),test("Test JSON 4",function(){var a=new RichTextparser;a.parse("[write({a:1,b:'123',c:Math.max(7,8,9)+10}.c + 2);]");var b=a.evaluate({});expect(b).toBe("21")}),test("Test for loop",function(){var a=new RichTextparser;a.parse("[for (var i=0; i &lt; 10; i++){write(i + ' | ');};]");var b=a.evaluate({});expect(b).toBe("0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | ")}),test("Test rich text html tags 1",function(){var a=new RichTextparser;a.parse("<container class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p>[</p><p>var test = 'some test';</p><p>if(true) {&nbsp;&nbsp;&nbsp;&nbsp;<br>&nbsp; &nbsp; test = <abc class=\"color7\">test;</abc><br>}</p><p>write('a ' + test);</p><p>write('ZZZZZ');</p><p><span>]&nbsp;</span></p></container>");var b=a.evaluate({});expect(b).toBe("<container class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p>a <abc class=\"color7\">some test</abc>ZZZZZ<span>&nbsp;</span></p></container>")}),test("Test rich text html tags 2",function(){var a=new RichTextparser;a.parse("<span11 class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p><span22>[</span22></p><p><span33>var test = 'some test';</span33></p><p>if(true){</p><p>&nbsp;test = <span44 class=\"color7\">test;</span44></p><p>}</p><p><span55>write ('a ' + test);</span55></p><p><span66>write ('YYYYY ' );</span66></p><p><span77>]</span77></p></span11>");var b=a.evaluate({});expect(b).toBe("<span11 class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p><span22></span22><span55>a <span44 class=\"color7\"><span33>some test</span33></span44></span55><span66>YYYYY </span66><span77></span77></p></span11>")}),test("Test rich text html tags 3",function(){var a=new RichTextparser;a.parse("<container class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p1><span1>[</span1></p1><p2><span2>var test = 'some test';</span2></p2><p3>if(true){</p3><p4>&nbsp;test = <span3 class=\"color7\">test</span3><span4 class=\"color7\">;</span4></p4><p5>}</p5><p6><span5>write ('a ' + test);</span5></p6><p7><span6>write ('ZZZZZZ ' );</span6></p7><p8><span7><br></span7></p8><p9><span8><br></span8></p9><p10><span9>]</span9></p10></container>");var b=a.evaluate({});expect(b).toBe("<container class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p1><span1></span1></p1><p3></p3><p5></p5><p6><span5>a <p4><span3 class=\"color7\"><p2><span2>some test</span2></p2></span3><span4 class=\"color7\"></span4></p4></span5></p6><p7><span6>ZZZZZZ </span6></p7><p8><span7></span7></p8><p9><span8></span8></p9><p10><span9></span9></p10></container>")}),test("Test rich text html tags 4",function(){var a=new RichTextparser;a.parse("<span1 class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p><span2>[</span2></p><p><span3>var a = [];</span3></p><p><span4>var s = <span5 class=\"color11\">'1234'</span5>;</span4></p><p><span6>a.push(<span7 class=\"color7\">'1111'</span7>, <span8 class=\"color8\">'2222'</span8>);</span6></p><p><span9>a.push(s);</span9></p><p><span10>write(a.join(' | '));</span10></p><p><span11><br></span11></p><p><abc>write(s.charAt(0));</abc></p><p><span12>]</span12></p></span1>");var b=a.evaluate({});expect(b).toBe("<span1 class=\"textFitted responsiveColor responsiveFontSize responsiveFontFamily\"><p><span2></span2><span9><span6><span3></span3></span6></span9><span10>1111 | 2222 | 1234</span10><span11></span11><abc>1</abc><span12></span6></span9></span12></p></span1>")}),test("Multiple script sections",function(){var a=new RichTextparser;a.parse("test <p>[</p> <p>] test2 [</p>] test3");var b=a.evaluate({});expect(b).toBe("test <p> test2  test3")});